unit EnumIDListUnit;

interface

uses
	SubFolderUnit,
	Windows, SysUtils, Classes, ActiveX, ComObj, ShlObj;

type
	TEnumIDList = class(TComObject, IEnumIDList)
	private
		FItems: TSubFolderItems;
		FCurPos: Integer;
	protected
		function Next(celt: ULONG; out rgelt: PItemIDList;
			var pceltFetched: ULONG): HResult; virtual; stdcall;
		function Skip(celt: ULONG): HResult; virtual; stdcall;
		function Reset: HResult; virtual; stdcall;
		function Clone(out ppenum: IEnumIDList): HResult; virtual; stdcall;
	public
		constructor Create(const Items: TSubFolderItems);
	end;

const
	Class_EnumIDList: TGUID = '{595D2822-10B5-11D5-A253-00900001489D}';

implementation

uses
	ComServ;

{ TEnumIDList }

function TEnumIDList.Clone(out ppenum: IEnumIDList): HResult;
begin
	ppenum := TEnumIDList.Create (FItems);
	Result := S_OK;
end;

constructor TEnumIDList.Create(const Items: TSubFolderItems);
begin
	inherited Create;
	FItems := Items;
	FCurPos := Low (FItems);
end;

function TEnumIDList.Next(celt: ULONG; out rgelt: PItemIDList;
	var pceltFetched: ULONG): HResult;
var
	I: Integer;
	Malloc: IMalloc;
	List: PSubFolderList;
begin
	pceltFetched := High (FItems) - FCurPos + 1;
	if Integer (pceltFetched) > Integer (celt) then
		pceltFetched := celt
	else
		celt := pceltFetched;
	Result := SHGetMalloc (Malloc);
	if Result = NoError then begin
		List := Malloc.Alloc ((SizeOf (TSubFolderItem) + SizeOf (Word)) * celt);
		rgelt := PItemIDList (List);
		Malloc := nil;
		if Integer (celt) > 0 then begin
			if Assigned (List) then begin
				for I := 0 to celt - 1 do begin
					List^[0].cb := SizeOf (TSubFolderItem);
					List^[0].Name := FItems[FCurPos].Name;
					List^[1].cb := 0;
					Inc (FCurPos);
					List := @(List^[1].Name);
				end;
				Result := S_OK;
			end else
				Result := E_OutOfMemory;
		end else begin
			if Assigned (List) then
				List^[0].cb := 0;
			Result := S_False;
		end;
	end;
end;

function TEnumIDList.Reset: HResult;
begin
	FCurPos := Low (FItems);
	Result := S_OK;
end;

function TEnumIDList.Skip(celt: ULONG): HResult;
begin
	Inc (FCurPos, celt);
	Result := S_OK;
end;

initialization
	TComObjectFactory.Create(ComServer, TEnumIDList, Class_EnumIDList,
		'EnumIDList', '', ciInternal, tmApartment);
end.
