uses
	Windows, Classes;

{ Calculator-specific Types }
type
	{ Basic Enumeration Type }
	TGlobalLinkID = Cardinal;

	{ Enumeration Types }
	TCalcBool = Bool;
	TLinkPort = TGlobalLinkID;
	TLinkType = TGlobalLinkID;
	TCalcType = TGlobalLinkID;
	TCalcVarTypeID = Byte;

	{	Sets }
	TCalcVarAttr = Byte;

	{	Variable or Folder Name }
	TCalcVarName = array [0..9] of Char;

	{	Variable Structure }
	TCalcVar = packed record
		Version: Cardinal;
		CalcType: TCalcType;
		Folder,
		Name: TCalcVarName;
		TypeID: TCalcVarTypeID;
		Size: LongWord;
		Attr: TCalcVarAttr;
	end;

	{ Calculator Connection Handle }
	TLinkHandle = Pointer;

	{	Progress callback function
		Should return False if cancelled, True otherwise }
	TProgressCallBack = function(ID: Pointer; Progress: PDWord): TCalcBool; stdcall;

	{	Variable list callback function
		This type is called by GetVarList on every item found }
	TVarListCallBack = function(ID: Pointer; const NewVar: TCalcVar): TCalcBool; stdcall;

{ Calculator-specific Constants }
const
	{ TCalcBool }
	CALC_ERROR   = False;
	CALC_SUCCESS = True;

	{ TLinkPort Internal Constants }
	CALC_PORT_COM_MASK = $1000;
	CALC_PORT_LPT_MASK = $2000;

	{ TLinkPort }
	CALC_PORT_USER = 0;
	CALC_PORT_COM1 = CALC_PORT_COM_MASK + 1;
	CALC_PORT_COM2 = CALC_PORT_COM_MASK + 2;
	CALC_PORT_COM3 = CALC_PORT_COM_MASK + 3;
	CALC_PORT_COM4 = CALC_PORT_COM_MASK + 4;
	CALC_PORT_LPT1 = CALC_PORT_LPT_MASK + 1;
	CALC_PORT_LPT2 = CALC_PORT_LPT_MASK + 2;
	CALC_PORT_LPT3 = CALC_PORT_LPT_MASK + 3;
	CALC_PORT_LPT4 = CALC_PORT_LPT_MASK + 4;

	{ TLinkType }
	CALC_CABLE_USER         = 0;
	CALC_CABLE_BLACKLINK    = 1;
	CALC_CABLE_GRAPHLINK    = 2;
	CALC_CABLE_PARALLELLINK = 3;

	{ TCalcType Internal Constants }
	CALC_TYPE_PLUS_MASK = $1000;

	{	TCalcType }
	CALC_TYPE_ERROR    = 0;
	CALC_TYPE_TI73     = 73;
	CALC_TYPE_TI82     = 82;
	CALC_TYPE_TI83     = 83;
	CALC_TYPE_TI83PLUS = CALC_TYPE_TI83 + CALC_TYPE_PLUS_MASK;
	CALC_TYPE_TI85     = 85;
	CALC_TYPE_TI86     = 86;
	CALC_TYPE_TI89     = 89;
	CALC_TYPE_TI92     = 92;
	CALC_TYPE_TI92PLUS = CALC_TYPE_TI92 + CALC_TYPE_PLUS_MASK;

	{	TCalcVarAttr }
	CALC_VAR_ATTR_LOCKED   = $01;
	CALC_VAR_ATTR_ARCHIVED = $02;
