#! /bin/sh
#
# Build TIGCC objcopy under MSYS
# Adapted from the TIGCC-Linux/Unix script
# This script launches configure with the right arguments
# The tree must have been patched before doing this.
#
echo TIGCC script: Configuring, compiling and installing binutils...

cd libiberty; ./configure --host=mingw32 --target=m68k-coff --enable-targets=m68k-amigaos --disable-shared --enable-static --disable-multilib --disable-nls --disable-win32-registry

# Create dummy libiberty testuite makefile if the existing one is completely empty
if [ ! -s testsuite/Makefile ]
    then echo all: >>testsuite/Makefile;echo distclean: >>testsuite/Makefile;echo -e "\trm -f Makefile" >>testsuite/Makefile
fi

make CFLAGS='-Os -s'


cd ../bfd; ./configure  --host=mingw32 --target=m68k-coff --enable-targets=m68k-amigaos --disable-shared --enable-static --disable-multilib --disable-nls --disable-win32-registry

# Create dummy doc and po makefiles if the existing ones are completely empty
if [ ! -s doc/Makefile ]
    then echo all: >>doc/Makefile;echo distclean: >>doc/Makefile;echo -e "\trm -f Makefile" >>doc/Makefile
fi
if [ ! -s po/Makefile ]
    then echo all: >>po/Makefile;echo distclean: >>po/Makefile;echo -e "\trm -f Makefile" >>po/Makefile
fi

make CFLAGS='-Os -s'


cd ../opcodes; ./configure  --host=mingw32 --target=m68k-coff --enable-targets=m68k-amigaos --disable-shared --enable-static --disable-multilib --disable-nls --disable-win32-registry

# Create dummy po makefile if the existing one is completely empty
if [ ! -s po/Makefile ]
    then echo all: >>po/Makefile;echo distclean: >>po/Makefile;echo -e "\trm -f Makefile" >>po/Makefile
fi

make CFLAGS='-Os -s'


cd ../binutils; ./configure  --host=mingw32 --target=m68k-coff --enable-targets=m68k-amigaos --disable-shared --enable-static --disable-multilib --disable-nls --disable-win32-registry

# Create dummy doc and po makefiles if the existing ones are completely empty
if [ ! -s doc/Makefile ]
    then echo all: >>doc/Makefile;echo distclean: >>doc/Makefile;echo -e "\trm -f Makefile" >>doc/Makefile
fi
if [ ! -s po/Makefile ]
    then echo all: >>po/Makefile;echo distclean: >>po/Makefile;echo -e "\trm -f Makefile" >>po/Makefile
fi

make CFLAGS='-Os -s'



cp objcopy.exe ../../objcopy.exe

#Clean-up archive else we will get error for the next launch.binutils
cd ../libiberty; make distclean
cd ../bfd; make distclean
cd ../opcodes; make distclean
cd ../binutils; make distclean
cd ..; rm -Rfv bfd/doc bfd/po binutils/doc binutils/po libiberty/config.cache opcodes/po

echo Done.

