unit ProjectOptionsUnit;

interface

uses
	Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
	StdCtrls, ExtCtrls;

type
	TProjectOptionsForm = class(TForm)
		OKButton: TButton;
		CancelButton: TButton;
    TargetGroupBox: TGroupBox;
    ExecutableRadioButton: TRadioButton;
    ArchiveRadioButton: TRadioButton;
    PackCheckBox: TCheckBox;
    PackVarLabel: TLabel;
    PackVarEdit: TEdit;
    OptionsGroupBox: TGroupBox;
    Label1: TLabel;
    GCCSwitchesEdit: TEdit;
    AsmSwitchesEdit: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    LinkSwitchesEdit: TEdit;
    DebugInfoCheckBox: TCheckBox;
    StdLibCheckBox: TCheckBox;
    ExecutionGroupBox: TGroupBox;
    CommandLineEditLabel: TLabel;
    CommandLineEdit: TEdit;
    ProcessFileGroupBox: TGroupBox;
    ProcessFileEditLabel: TLabel;
    ProcessFileEdit: TEdit;
    BrowseButton: TButton;
		BrowseDialog: TOpenDialog;
    Label4: TLabel;
    AsSwitchesEdit: TEdit;
    Label5: TLabel;
    LdSwitchesEdit: TEdit;
		procedure FormShow(Sender: TObject);
		procedure PackCheckBoxClick(Sender: TObject);
		procedure PackVarEditChange(Sender: TObject);
		procedure TargetRadioButtonClick(Sender: TObject);
    procedure BrowseButtonClick(Sender: TObject);
	private
	public
	end;

implementation

{$R *.DFM}

uses
	MasterUnit,
	MainUnit;

procedure TProjectOptionsForm.FormShow(Sender: TObject);
begin
	TargetRadioButtonClick (Sender);
end;

procedure TProjectOptionsForm.PackCheckBoxClick(Sender: TObject);
begin
	PackVarEdit.Enabled := PackCheckBox.Checked;
	PackVarLabel.Enabled := PackVarEdit.Enabled;
	PackVarEditChange (Sender);
end;

procedure TProjectOptionsForm.PackVarEditChange(Sender: TObject);
var
	S: string;
	I: Integer;
	OK: Boolean;
begin
	if PackCheckBox.Checked then begin
		S := PackVarEdit.Text;
		OK := (Length (S) > 0) and (Length (S) <= 8) and (IsCharAlpha (S [1]) or (S [1] in ['A'..'Z', 'a'..'z'])) and (LowerCase (S) <> LowerCase (MainForm.TopNode.Text));
		if OK then
			for I := Length (S) downto 1 do
				if (not (IsCharAlphaNumeric (S [I]) or (S [I] in ['A'..'Z', 'a'..'z', '0'..'9', '_']))) or ((I = 1) and (S [I] = '_')) then begin
					OK := False;
					Break;
				end;
		OKButton.Enabled := OK;
	end else
		OKButton.Enabled := True;
end;

procedure TProjectOptionsForm.TargetRadioButtonClick(Sender: TObject);
begin
	PackCheckBox.Enabled := ExecutableRadioButton.Checked and (ssPack in SpecialSupport);
	if not PackCheckBox.Enabled then
		PackCheckBox.Checked := False;
	PackCheckBoxClick (Sender);
	ExecutionGroupBox.Enabled := ExecutableRadioButton.Checked;
	CommandLineEdit.Enabled := ExecutionGroupBox.Enabled;
	CommandLineEditLabel.Enabled := CommandLineEdit.Enabled;
	if not CommandLineEdit.Enabled then
		CommandLineEdit.Text := '';
	ProcessFileGroupBox.Enabled := ExecutableRadioButton.Checked;
	ProcessFileEdit.Enabled := ProcessFileGroupBox.Enabled;
	ProcessFileEditLabel.Enabled := ProcessFileEdit.Enabled;
	if not ProcessFileEdit.Enabled then
		ProcessFileEdit.Text := '';
end;

procedure TProjectOptionsForm.BrowseButtonClick(Sender: TObject);
var
	S: string;
begin
	with BrowseDialog do begin
		S := ProcessFileEdit.Text;
		if (Length (S) > 0) and ((S [1] = '"') or (Pos (' ', S) <= 0)) then begin
			if S [1] = '"' then begin
				Delete (S, 1, 1);
				if Pos ('"', S) > 0 then
					Delete (S, Pos ('"', S), Length (S));
			end;
			FileName := S;
		end;
		if Execute then
			ProcessFileEdit.Text := '"' + FileName + '" "($TI89File)" "($TI92PlusFile)"';
	end;
end;

end.
