/*  SHARED - shared files
 *
 *  Copyright (C) 2002  Romain Lievin
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributelabeld in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef _MISC_H
#define _MISC_H


/* global enumerations */
enum Boolean_ 	{FALSE,TRUE};
typedef enum Boolean_ Boolean;

/* constants */
#define MAX_CHARS	65535
#define MAX_ARRAY_FILES 256

#define DEVNULL                 "> /dev/null"

/* functions */
int delete(char *filename);
int execute(char *cmdline);

int dyn_file_array_size(char **array, int *size);
int dyn_file_array_add(char *file, char ***array, int *file_count);
void dyn_file_array_free(char **files);

char* encapsulate_long_filename(const char *file);
char* tail_long_filename(char *file);
char *change_extension(char *file, char *newext);


#endif
